diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-frame-exchange-manager.cc ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.cc
--- ns-3.43/src/wifi/model/eht/eht-frame-exchange-manager.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.cc	2025-03-09 16:55:49.787372600 -0700
@@ -1179,32 +1465,97 @@
             m_ongoingTxopEnd = Simulator::Schedule(m_phy->GetSifs() + NanoSeconds(1),
                                                    &EhtFrameExchangeManager::TxopEnd,
                                                    this,
-                                                   hdr.GetAddr2());
+                                                   sender);
         }
     }
 
-    // We impose that an aux PHY is only able to receive an ICF, a CTS or a management frame
-    // (we are interested in receiving mainly Beacon frames). Note that other frames are still
-    // post-processed, e.g., used to set the NAV and the TXOP holder.
+    if (!m_icfReceived && ShallDropReceivedMpdu(mpdu))
+    {
+        NS_LOG_DEBUG("Drop received MPDU: " << *mpdu);
+        return;
+    }
+
+    HeFrameExchangeManager::ReceiveMpdu(mpdu, rxSignalInfo, txVector, inAmpdu);
+
+    if (m_apMac && GetWifiRemoteStationManager()->GetEmlsrEnabled(sender))
+    {
+        if (hdr.IsRts() && !m_sendCtsEvent.IsPending())
+        {
+            // received RTS but did not send CTS (e.g., NAV busy), start transition delay
+            EmlsrSwitchToListening(sender, Time{0});
+            return;
+        }
+
+        // if the AP MLD received an MPDU from an EMLSR client that is starting an UL TXOP,
+        // block transmissions to the EMLSR client on other links
+        CheckEmlsrClientStartingTxop(hdr, txVector);
+    }
+}
+
+void
+EhtFrameExchangeManager::EndReceiveAmpdu(Ptr<const WifiPsdu> psdu,
+                                         const RxSignalInfo& rxSignalInfo,
+                                         const WifiTxVector& txVector,
+                                         const std::vector<bool>& perMpduStatus)
+{
+    NS_LOG_FUNCTION(
+        this << *psdu << rxSignalInfo << txVector << perMpduStatus.size()
+             << std::all_of(perMpduStatus.begin(), perMpduStatus.end(), [](bool v) { return v; }));
+
+    if (ShallDropReceivedMpdu(*psdu->begin()))
+    {
+        return;
+    }
+
+    HeFrameExchangeManager::EndReceiveAmpdu(psdu, rxSignalInfo, txVector, perMpduStatus);
+}
+
+bool
+EhtFrameExchangeManager::ShallDropReceivedMpdu(Ptr<const WifiMpdu> mpdu) const
+{
+    NS_LOG_FUNCTION(this << *mpdu);
+
+    // this function only checks frames that shall be dropped by an EMLSR client
+    if (!m_staMac || !m_staMac->IsEmlsrLink(m_linkId))
+    {
+        return false;
+    }
+
+    const auto& hdr = mpdu->GetHeader();
+
+    // We impose that an aux PHY is only able to receive an ICF, a CF-End, a CTS or a management
+    // frame (we are interested in receiving mainly Beacon frames). Note that other frames are
+    // still post-processed, e.g., used to set the NAV and the TXOP holder.
     // The motivation is that, e.g., an AP MLD may send an ICF to EMLSR clients A and B;
     // A responds while B does not; the AP MLD sends a DL MU PPDU to both clients followed
     // by an MU-BAR to solicit a BlockAck from both clients. If an aux PHY of client B is
     // operating on this link, the MU-BAR will be received and a TB PPDU response sent
     // through the aux PHY.
-    if (m_staMac && m_staMac->IsEmlsrLink(m_linkId) &&
-        m_mac->GetLinkForPhy(m_staMac->GetEmlsrManager()->GetMainPhyId()) != m_linkId &&
-        !icfReceived && !mpdu->GetHeader().IsCts() && !mpdu->GetHeader().IsMgt())
+    if (hdr.IsMgt() || hdr.IsCts() || hdr.IsCfEnd() || (hdr.IsData() && hdr.GetAddr1().IsGroup()))
     {
-        NS_LOG_DEBUG("Dropping " << *mpdu << " received by an aux PHY on link " << +m_linkId);
-        return;
+        return false;
     }
 
-    HeFrameExchangeManager::ReceiveMpdu(mpdu, rxSignalInfo, txVector, inAmpdu);
+    // other frames cannot be received by an aux PHY
+    if (m_mac->GetLinkForPhy(m_staMac->GetEmlsrManager()->GetMainPhyId()) != m_linkId)
+    {
+        NS_LOG_DEBUG("Dropping " << *mpdu << " received by an aux PHY on link " << +m_linkId);
+        return true;
+    }
 
-    if (icfReceived)
+    // other frames cannot be received by the main PHY when not involved in any TXOP
+    if (!m_ongoingTxopEnd.IsPending() &&
+        std::none_of(wifiAcList.cbegin(), wifiAcList.cend(), [=, this](const auto& aciAcPair) {
+            return m_mac->GetQosTxop(aciAcPair.first)->GetTxopStartTime(m_linkId).has_value();
+        }))
     {
-        m_staMac->GetEmlsrManager()->NotifyIcfReceived(m_linkId);
+        NS_LOG_DEBUG("Dropping " << *mpdu << " received by main PHY on link " << +m_linkId
+                                 << " while no TXOP is ongoing");
+        return true;
     }
+
+    // other frames can be received by the main PHY when involved in a TXOP
+    return false;
 }
 
 bool
@@ -1315,7 +1666,7 @@
 {
     NS_LOG_FUNCTION(this << txopHolder.has_value());
 
-    if (m_phy && m_phy->IsReceivingPhyHeader())
+    if (m_phy && m_phy->GetInfoIfRxingPhyHeader())
     {
         // we may get here because the PHY has not issued the PHY-RXSTART.indication before
         // the expiration of the timer started to detect new received frames, but the PHY is
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-frame-exchange-manager.h ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.h
--- ns-3.43/src/wifi/model/eht/eht-frame-exchange-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.h	2025-03-09 16:55:49.787372600 -0700
@@ -24,7 +24,7 @@
 class MgtEmlOmn;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Reasons for an EMLSR client to drop an ICF
  */
 enum class WifiIcfDrop : uint8_t
@@ -37,11 +37,11 @@
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the stream
- * \param reason the reason for dropping the ICF
- * \returns a reference to the stream
+ * @param os the stream
+ * @param reason the reason for dropping the ICF
+ * @returns a reference to the stream
  */
 inline std::ostream&
 operator<<(std::ostream& os, WifiIcfDrop reason)
@@ -65,7 +65,7 @@
 }
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * EhtFrameExchangeManager handles the frame exchange sequences
  * for EHT stations.
@@ -74,8 +74,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     EhtFrameExchangeManager();
@@ -88,8 +88,8 @@
     /**
      * Send an EML Operating Mode Notification frame to the given station.
      *
-     * \param dest the MAC address of the receiver
-     * \param frame the EML Operating Mode Notification frame to send
+     * @param dest the MAC address of the receiver
+     * @param frame the EML Operating Mode Notification frame to send
      */
     void SendEmlOmn(const Mac48Address& dest, const MgtEmlOmn& frame);
 
@@ -98,16 +98,16 @@
      * there is no such information for the given station and the station is affiliated with an MLD,
      * return the RSSI of the most recent packet received from another station of the same MLD.
      *
-     * \param address of the remote station
-     * \return the RSSI of the most recent packet received from the remote station
+     * @param address of the remote station
+     * @return the RSSI of the most recent packet received from the remote station
      */
     std::optional<dBm_u> GetMostRecentRssi(const Mac48Address& address) const override;
 
     /**
-     * \param psdu the given PSDU
-     * \param aid the AID of an EMLSR client
-     * \param address the link MAC address of an EMLSR client
-     * \return whether the EMLSR client having the given AID and MAC address shall switch back to
+     * @param psdu the given PSDU
+     * @param aid the AID of an EMLSR client
+     * @param address the link MAC address of an EMLSR client
+     * @return whether the EMLSR client having the given AID and MAC address shall switch back to
      *         the listening operation when receiving the given PSDU
      */
     bool GetEmlsrSwitchToListening(Ptr<const WifiPsdu> psdu,
@@ -118,14 +118,14 @@
      * Notify that the given PHY will switch channel to operate on another EMLSR link
      * after the given delay.
      *
-     * \param phy the given PHY
-     * \param linkId the ID of the EMLSR link on which the given PHY is operating
-     * \param delay the delay after which the channel switch will be completed
+     * @param phy the given PHY
+     * @param linkId the ID of the EMLSR link on which the given PHY is operating
+     * @param delay the delay after which the channel switch will be completed
      */
     void NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy, uint8_t linkId, Time delay);
 
     /**
-     * \return whether this is an EMLSR link that has been blocked because another EMLSR link
+     * @return whether this is an EMLSR link that has been blocked because another EMLSR link
      *         is being used
      */
     bool UsingOtherEmlsrLink() const;
@@ -136,9 +136,9 @@
      * on the other links). This method is intended to be called when an MPDU (possibly within
      * an A-MPDU) is received or when the reception of the MAC header in an MPDU is notified.
      *
-     * \param hdr the MAC header of the received (or being received) MPDU
-     * \param txVector the TXVECTOR used to transmit the frame received (or being received)
-     * \return whether the frame received (or being received) is sent by an EMLSR client to start
+     * @param hdr the MAC header of the received (or being received) MPDU
+     * @param txVector the TXVECTOR used to transmit the frame received (or being received)
+     * @return whether the frame received (or being received) is sent by an EMLSR client to start
      *         an UL TXOP
      */
     bool CheckEmlsrClientStartingTxop(const WifiMacHeader& hdr, const WifiTxVector& txVector);
@@ -150,17 +150,26 @@
      * This method blocks the transmissions on all the EMLSR links of the given EMLSR client until
      * the transition delay advertised by the EMLSR client expires.
      *
-     * \param address the link MAC address of the given EMLSR client
-     * \param delay the given delay
+     * @param address the link MAC address of the given EMLSR client
+     * @param delay the given delay
      */
-    void EmlsrSwitchToListening(const Mac48Address& address, const Time& delay);
+    void EmlsrSwitchToListening(Mac48Address address, const Time& delay);
 
     /**
-     * \return a reference to the event indicating the possible end of the current TXOP (of
+     * @return a reference to the event indicating the possible end of the current TXOP (of
      *         which this device is not the holder)
      */
     EventId& GetOngoingTxopEndEvent();
 
+    /**
+     * Set the padding and the TXVECTOR of the given Trigger Frame, in case it is an Initial
+     * Control Frame for some EMLSR client(s).
+     *
+     * @param trigger the given Trigger Frame
+     * @param txVector the TXVECTOR used to transmit the Trigger Frame
+     */
+    void SetIcfPaddingAndTxVector(CtrlTriggerHeader& trigger, WifiTxVector& txVector) const;
+
     /// ICF drop reason traced callback (WifiMac exposes this trace source)
     TracedCallback<WifiIcfDrop, uint8_t> m_icfDropCallback;
 
@@ -169,13 +178,13 @@
     void RxStartIndication(WifiTxVector txVector, Time psduDuration) override;
     void ForwardPsduDown(Ptr<const WifiPsdu> psdu, WifiTxVector& txVector) override;
     void ForwardPsduMapDown(WifiConstPsduMap psduMap, WifiTxVector& txVector) override;
-    void SendMuRts(const WifiTxParameters& txParams) override;
     void CtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts, const WifiTxVector& txVector) override;
+    bool GetUpdateCwOnCtsTimeout() const override;
     void SendCtsAfterMuRts(const WifiMacHeader& muRtsHdr,
                            const CtrlTriggerHeader& trigger,
                            double muRtsSnr) override;
     void TransmissionSucceeded() override;
-    void TransmissionFailed() override;
+    void TransmissionFailed(bool forceCurrentCw = false) override;
     void NotifyChannelReleased(Ptr<Txop> txop) override;
     void PreProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
     void PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
@@ -183,59 +192,119 @@
                      RxSignalInfo rxSignalInfo,
                      const WifiTxVector& txVector,
                      bool inAmpdu) override;
+    void EndReceiveAmpdu(Ptr<const WifiPsdu> psdu,
+                         const RxSignalInfo& rxSignalInfo,
+                         const WifiTxVector& txVector,
+                         const std::vector<bool>& perMpduStatus) override;
     void NavResetTimeout() override;
     void IntraBssNavResetTimeout() override;
     void SendCtsAfterRts(const WifiMacHeader& rtsHdr, WifiMode rtsTxMode, double rtsSnr) override;
     void PsduRxError(Ptr<const WifiPsdu> psdu) override;
+    void ReceivedQosNullAfterBsrpTf(Mac48Address sender) override;
+    void SendQosNullFramesInTbPpdu(const CtrlTriggerHeader& trigger,
+                                   const WifiMacHeader& hdr) override;
+    void TbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations) override;
+    void BlockAcksInTbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations) override;
+    void ProtectionCompleted() override;
+
+    /**
+     * @return whether this is an EMLSR client that cannot respond to an ICF received a SIFS before
+     */
+    bool EmlsrClientCannotRespondToIcf() const;
+
+    /**
+     * Check if the MPDU that has been received on this link shall be dropped. In our model,
+     * an aux PHY, or the main PHY that is not involved in any TXOP, can receive:
+     * - management frames
+     * - CTS
+     * - CF-End
+     * - broadcast data frames
+     * Note that this method does not attempt to detect if the given MPDU is an ICF (this is done
+     * by ReceiveMpdu).
+     *
+     * @param mpdu the MPDU that has been received
+     * @return whether the given MPDU shall be dropped
+     */
+    bool ShallDropReceivedMpdu(Ptr<const WifiMpdu> mpdu) const;
+
+    /**
+     * Check whether all the stations that did not respond (to a certain frame) are EMLSR clients
+     * trying to start an UL TXOP on another link.
+     *
+     * @param staMissedResponseFrom stations that did not respond
+     * @return whether all the stations that did not respond are EMLSR clients trying to start an
+     *         UL TXOP on another link
+     */
+    bool IsCrossLinkCollision(const std::set<Mac48Address>& staMissedResponseFrom) const;
+
+    /**
+     * Unblock transmissions on all the links of the given EMLSR client, provided that the latter
+     * is not involved in any DL or UL TXOP on another link.
+     *
+     * @param address the link MAC address of the given EMLSR client
+     * @return whether transmissions could be unblocked
+     */
+    bool UnblockEmlsrLinksIfAllowed(Mac48Address address);
 
   private:
     /**
-     * \return whether the received ICF must be dropped because we are unable to process it
+     * @return whether the received ICF must be dropped because we are unable to process it
      *         (e.g., another EMLSR link is being used or there is no time for main PHY switch)
      */
     bool DropReceivedIcf();
 
     /**
+     * For each EMLSR client in the given set of clients that did not respond to a frame requesting
+     * a response from multiple clients, have the client switch to listening or simply unblock
+     * links depending on whether the EMLSR client was protected or not.
+     *
+     * @param clients the given set of clients
+     */
+    void SwitchToListeningOrUnblockLinks(const std::set<Mac48Address>& clients);
+
+    /**
      * Generate an in-device interference of the given power on the given link for the given
      * duration.
      *
-     * \param linkId the ID of the link on which in-device interference is generated
-     * \param duration the duration of the in-device interference
-     * \param txPower the TX power
+     * @param linkId the ID of the link on which in-device interference is generated
+     * @param duration the duration of the in-device interference
+     * @param txPower the TX power
      */
     void GenerateInDeviceInterference(uint8_t linkId, Time duration, Watt_u txPower);
 
     /**
      * Update the TXOP end timer when starting a frame transmission.
      *
-     * \param txDuration the TX duration of the frame being transmitted
-     * \param durationId the Duration/ID value carried by the frame being transmitted
+     * @param txDuration the TX duration of the frame being transmitted
+     * @param durationId the Duration/ID value carried by the frame being transmitted
      */
     void UpdateTxopEndOnTxStart(Time txDuration, Time durationId);
 
     /**
      * Update the TXOP end timer when receiving a PHY-RXSTART.indication.
      *
-     * \param psduDuration the TX duration of the PSDU being received
+     * @param psduDuration the TX duration of the PSDU being received
      */
     void UpdateTxopEndOnRxStartIndication(Time psduDuration);
 
     /**
      * Update the TXOP end timer when a frame reception ends.
      *
-     * \param durationId the Duration/ID value carried by the received frame
+     * @param durationId the Duration/ID value carried by the received frame
      */
     void UpdateTxopEndOnRxEnd(Time durationId);
 
     /**
      * Take actions when a TXOP (of which we are not the holder) ends.
      *
-     * \param txopHolder the holder of the TXOP (if any)
+     * @param txopHolder the holder of the TXOP (if any)
      */
     void TxopEnd(const std::optional<Mac48Address>& txopHolder);
 
-    EventId m_ongoingTxopEnd; //!< event indicating the possible end of the current TXOP (of which
-                              //!< we are not the holder)
+    bool m_icfReceived{false}; //!< whether an ICF has been received and needs to be notified to
+                               //!< the EMLSR manager after post-processing the frame
+    EventId m_ongoingTxopEnd;  //!< event indicating the possible end of the current TXOP (of which
+                               //!< we are not the holder)
     std::unordered_map<Mac48Address, EventId, WifiAddressHash>
         m_transDelayTimer; //!< MLD address-indexed map of transition delay timers
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-operation.cc ns-3.44/src/wifi/model/eht/eht-operation.cc
--- ns-3.43/src/wifi/model/eht/eht-operation.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-operation.cc	2025-03-09 16:55:49.787372600 -0700
@@ -8,7 +8,7 @@
 
 #include "eht-operation.h"
 
-#include <ns3/assert.h>
+#include "ns3/assert.h"
 
 #include <algorithm>
 
@@ -64,10 +64,10 @@
 
 /**
  * set the max Tx/Rx NSS for input MCS index range
- * \param vec vector of max NSS per MCS
- * \param maxNss max NSS for input MCS range
- * \param mcsStart MCS index start
- * \param mcsEnd MCS index end
+ * @param vec vector of max NSS per MCS
+ * @param maxNss max NSS for input MCS range
+ * @param mcsStart MCS index start
+ * @param mcsEnd MCS index end
  */
 void
 SetMaxNss(std::vector<uint8_t>& vec, uint8_t maxNss, uint8_t mcsStart, uint8_t mcsEnd)
@@ -83,10 +83,10 @@
 
 /**
  * Get the max Tx/Rx NSS for input MCS index range
- * \param vec vector of max NSS per MCS
- * \param mcsStart MCS index start
- * \param mcsEnd MCS index end
- * \return max Rx NSS
+ * @param vec vector of max NSS per MCS
+ * @param mcsStart MCS index start
+ * @param mcsEnd MCS index end
+ * @return max Rx NSS
  */
 uint32_t
 GetMaxNss(const std::vector<uint8_t>& vec, uint8_t mcsStart, uint8_t mcsEnd)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-operation.h ns-3.44/src/wifi/model/eht/eht-operation.h
--- ns-3.43/src/wifi/model/eht/eht-operation.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-operation.h	2025-03-09 16:55:49.787372600 -0700
@@ -9,7 +9,7 @@
 #ifndef EHT_OPERATION_H
 #define EHT_OPERATION_H
 
-#include <ns3/wifi-information-element.h>
+#include "ns3/wifi-information-element.h"
 
 #include <optional>
 #include <vector>
@@ -43,8 +43,8 @@
 constexpr uint8_t WIFI_DEFAULT_GRP_BU_EXP = 0;
 
 /**
- * \brief EHT Operation Information Element
- * \ingroup wifi
+ * @brief EHT Operation Information Element
+ * @ingroup wifi
  *
  * This class serializes and deserializes
  * the EHT Operation Information Element
@@ -74,14 +74,14 @@
         /**
          * Serialize the EHT Operation Parameters subfield
          *
-         * \param start iterator pointing to where the subfield should be written to
+         * @param start iterator pointing to where the subfield should be written to
          */
         void Serialize(Buffer::Iterator& start) const;
         /**
          * Deserialize the EHT Operation Parameters subfield
          *
-         * \param start iterator pointing to where the subfield should be read from
-         * \return the number of octets read
+         * @param start iterator pointing to where the subfield should be read from
+         * @return the number of octets read
          */
         uint16_t Deserialize(Buffer::Iterator start);
     };
@@ -109,15 +109,15 @@
         /**
          * Serialize the EHT Operation Information subfield
          *
-         * \param start iterator pointing to where the subfield should be written to
+         * @param start iterator pointing to where the subfield should be written to
          */
         void Serialize(Buffer::Iterator& start) const;
         /**
          * Deserialize the EHT Operation Information subfield
          *
-         * \param start iterator pointing to where the subfield should be read from
-         * \param disabledSubchBmPresent EHT Operation Param Disabled Subchannel Bitmap Present
-         * \return the number of octets read
+         * @param start iterator pointing to where the subfield should be read from
+         * @param disabledSubchBmPresent EHT Operation Param Disabled Subchannel Bitmap Present
+         * @return the number of octets read
          */
         uint16_t Deserialize(Buffer::Iterator start, bool disabledSubchBmPresent);
     };
@@ -134,14 +134,14 @@
         /**
          * Serialize the Basic EHT-MCS and NSS Set subfield
          *
-         * \param start iterator pointing to where the subfield should be written to
+         * @param start iterator pointing to where the subfield should be written to
          */
         void Serialize(Buffer::Iterator& start) const;
         /**
          * Deserialize the Basic EHT-MCS and NSS Set subfield
          *
-         * \param start iterator pointing to where the subfield should be read from
-         * \return the number of octets read
+         * @param start iterator pointing to where the subfield should be read from
+         * @return the number of octets read
          */
         uint16_t Deserialize(Buffer::Iterator start);
     };
@@ -153,16 +153,16 @@
 
     /**
      * Set the max Rx NSS for input MCS index range
-     * \param maxNss the maximum supported Rx NSS for MCS group
-     * \param mcsStart MCS index start
-     * \param mcsEnd MCS index end
+     * @param maxNss the maximum supported Rx NSS for MCS group
+     * @param mcsStart MCS index start
+     * @param mcsEnd MCS index end
      */
     void SetMaxRxNss(uint8_t maxNss, uint8_t mcsStart, uint8_t mcsEnd);
     /**
      * Set the max Tx NSS for input MCS index range
-     * \param maxNss the maximum supported Rx NSS for MCS group
-     * \param mcsStart MCS index start
-     * \param mcsEnd MCS index end
+     * @param maxNss the maximum supported Rx NSS for MCS group
+     * @param mcsStart MCS index start
+     * @param mcsEnd MCS index end
      */
     void SetMaxTxNss(uint8_t maxNss, uint8_t mcsStart, uint8_t mcsEnd);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/eht-phy.cc ns-3.44/src/wifi/model/eht/eht-phy.cc
--- ns-3.43/src/wifi/model/eht/eht-phy.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/eht-phy.cc	2025-03-09 16:55:49.787372600 -0700
@@ -129,7 +129,7 @@
         return EhtPpdu::GetEhtSigFieldSize(
             txVector.GetChannelWidth(),
             txVector.GetRuAllocation(
-                m_wifiPhy ? m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20) : 0),
+                m_wifiPhy ? m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(MHz_u{20}) : 0),
             txVector.GetEhtPpduType(),
             txVector.IsSigBCompression(),
             txVector.IsSigBCompression() ? txVector.GetHeMuUserInfoMap().size() : 0);
